/////////////////////////////////////
//PIC18 BootLoader             //
//޸HTSoftBootLoader     //
//                                 //
//޸ģ                     //
//      20051                  //
//  __      __                     //
// (  / _   _/ '(__/_   _          //
//__)/)(/()/__/  / (//)(/ @126.com //
//                    _/           //
////////////////////////////////////\

#ifndef _BOOTLDR_H_
#define _BOOTLDR_H_

//궨壬ǳҪϸ

#define BOOT_TIMEOUT  2       //ʱʱ/
#define FILL_BYTE     0xFF    //ռֽ
#define PROG_START    0x200   //ûʼλ

#define INTRC 1               //ʹ
#define BAUD 19200            //
#define FOSC 8000000L         //Ƶ
#define NINE 0                //Ƿʹõ9λ 0=8λ
#define HIGH_SPEED 1

#define BOOT_TIME_DELAY 1     //ʱʽ
#define BOOT_SIGNAL     0     //źʽ
#define USE_EXTEND_HEX  0     //ǷչHEX룬ʹÿԽʡ

#define BOOT_SIGNAL_PORT  RA0 //źţﶨΪRA0
#define BOOT_SIGNAL_LEVEL 1   //ƽ 1=ߵƽ

#define USEWDT 1              //1=ʹÿŹ

#define RS485  1              //RS485ʽ

#if RS485==1
#define TXEn RB0              //RS485ʹ
#endif

//ͬ
#define CONFIRM_TIME      9   //ֽͬ
const unsigned char CONFIRM_DATA[]={0x48,0xC2,0x58,0x5E,0x00,0x18,0x36,0x22,0x99,0x11,0x12};

#define USE_ECHOBACK  1       //ʱǷӦ

////////////////////////
// ROMSIZE С   //
//ûаͺ//
//з      //
////////////////////////
#if !defined(MPLAB_ICD)
  #define MEM_TOP (unsigned int)(ROMSIZE&0xFFFF)
  #if ROMSIZE >= 65536
    #define UPPER_ADDRESS_BYTE  (unsigned char)((ROMSIZE>>16)&0xFF)
  #endif
#else
  #if defined(_18F2220) || defined(_18F4220)
    #define MEM_TOP 0x0DC0
  #elif defined(_18F1220)
    #define MEM_TOP 0x0E80
  #elif defined(_18F2439) || defined(_18F4439)
    #define MEM_TOP 0x15C0
  #elif defined(_18F2320) || defined(_18F4320)
    #define MEM_TOP 0x1DC0
  #elif defined(_18F1320)
    #define MEM_TOP 0x1E80
  #elif defined(_18F2539) || defined(_18F4539)
    #define MEM_TOP 0x2DC0
  #elif defined(_18F242) || defined(_18F442) || defined(_18F248) || defined(_18F448)
    #define MEM_TOP 0x3DC0
  #elif defined(_18F6520) || defined(_18F8520)
    #define MEM_TOP 0x6DC0
  #elif defined(_18F252) || defined(_18F452) || defined(_18F258) || defined(_18F458)
    #define MEM_TOP 0x7DC0
  #elif defined(_18F6525) || defined(_18F6585) || defined(_18F8525) || defined(_18F8585)
    #define MEM_TOP 0xBDC0
  #elif defined(_18F6620) || defined(_18F8620) || defined(_18F6621) || defined(_18F8621) || \
      defined(_18F6680) || defined(_18F8680)
    #define MEM_TOP 0xFDC0
  #elif defined(_18F6720) || defined(_18F8720)
    #define UPPER_ADDRESS_BYTE  0x01
    #define MEM_TOP 0xFDC0
  #endif
#endif

#if !defined(MEM_TOP)
  #warning Uncertain program memory size
  #define MEM_TOP 0x8000
#endif

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

////////////////
//²Ҫ޸//
////////////////

#define OUTPUT  0
#define INPUT   1

#define DIVIDER ((int)(FOSC/(16UL * BAUD) -1))

#if NINE == 1
#define NINE_BITS 0x40
#else
#define NINE_BITS 0
#endif

#if HIGH_SPEED == 1
#define SPEED 0x4
#else
#define SPEED 0
#endif

/* ʼ */
#define init_comms()                     \
        {                                \
          SPBRG = DIVIDER;               \
          TXSTA = (SPEED|NINE_BITS|0x20);\
          RCSTA = (NINE_BITS|0x90);      \
          TRISB1= OUTPUT;                \
          TRISB0= OUTPUT;                \
        }

#ifndef NOP()
#define NOP() asm("nop")
#endif

#ifndef RESET()
#define RESET() asm("reset")
#endif

#ifndef CLRWDT()
#define CLRWDT() asm("clrwdt")
#endif

/*  */
#define FLASH  EEPGD==1
#define EEPROM EEPGD==0
#define CONFIG CFGS==1

/* hex ¼ */
#define DATA 0
#define END  1
#define EXTEND_ADDRESS 4

#endif
